HTMLBuilder (Other Classes)
Date: 2016-02-03

org.apache.html.dom

## Class HTMLBuilder

- java.lang.Object
- - org.apache.html.dom.HTMLBuilder

- All Implemented Interfaces:
    org.xml.sax.DocumentHandler

      public class HTMLBuilder
      extends java.lang.Object
      implements org.xml.sax.DocumentHandler

  This is a SAX document handler that is used to build an HTML document. It can build a document from any SAX parser, but is specifically tuned for working with the OpenXML HTML parser.
  Version:
    $Revision: 1029415 $ $Date: 2010-10-31 13:02:22 -0400 (Sun, 31 Oct 2010) $
  Author:
    Assaf Arkin

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected org.apache.xerces.dom.ElementImpl` | `_current` The current node in the document into which elements, text and other nodes will be inserted.
    `protected HTMLDocumentImpl` | `_document` The document that is being built.
    `protected java.util.Vector` | `_preRootNodes` The document is only created the same time as the document element, however, certain nodes may precede the document element (comment and PI), and they are accumulated in this vector.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `HTMLBuilder()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `characters(char[] text, int start, int length)` Receive notification of character data.
    `void` | `characters(java.lang.String text)`
    `void` | `endDocument()` Receive notification of the end of a document.
    `void` | `endElement(java.lang.String tagName)` Receive notification of the end of an element.
    `org.w3c.dom.html.HTMLDocument` | `getHTMLDocument()`
    `void` | `ignorableWhitespace(char[] text, int start, int length)` Receive notification of ignorable whitespace in element content.
    `void` | `processingInstruction(java.lang.String target, java.lang.String instruction)` Receive notification of a processing instruction.
    `void` | `setDocumentLocator(org.xml.sax.Locator locator)` Receive an object for locating the origin of SAX document events.
    `void` | `startDocument()` Receive notification of the beginning of a document.
    `void` | `startElement(java.lang.String tagName, org.xml.sax.AttributeList attrList)` Receive notification of the beginning of an element.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _document

          protected HTMLDocumentImpl _document

      The document that is being built.

    - #### _current

          protected org.apache.xerces.dom.ElementImpl _current

      The current node in the document into which elements, text and other nodes will be inserted. This starts as the document itself and reflects each element that is currently being parsed.

    - #### _preRootNodes

          protected java.util.Vector _preRootNodes

      The document is only created the same time as the document element, however, certain nodes may precede the document element (comment and PI), and they are accumulated in this vector.

  - ### Constructor Detail

    - #### HTMLBuilder

          public HTMLBuilder()

  - ### Method Detail

    - #### startDocument

          public void startDocument()
                             throws org.xml.sax.SAXException

      Description copied from interface: `org.xml.sax.DocumentHandler`
      Receive notification of the beginning of a document.

      The SAX parser will invoke this method only once, before any other methods in this interface or in DTDHandler (except for setDocumentLocator).

      Specified by:
        `startDocument` in interface `org.xml.sax.DocumentHandler`
      Throws:
        `org.xml.sax.SAXException` - Any SAX exception, possibly wrapping another exception.

    - #### endDocument

          public void endDocument()
                           throws org.xml.sax.SAXException

      Description copied from interface: `org.xml.sax.DocumentHandler`
      Receive notification of the end of a document.

      The SAX parser will invoke this method only once, and it will be the last method invoked during the parse. The parser shall not invoke this method until it has either abandoned parsing (because of an unrecoverable error) or reached the end of input.

      Specified by:
        `endDocument` in interface `org.xml.sax.DocumentHandler`
      Throws:
        `org.xml.sax.SAXException` - Any SAX exception, possibly wrapping another exception.

    - #### startElement

          public void startElement(java.lang.String tagName,
                          org.xml.sax.AttributeList attrList)
                            throws org.xml.sax.SAXException

      Description copied from interface: `org.xml.sax.DocumentHandler`
      Receive notification of the beginning of an element.

      The Parser will invoke this method at the beginning of every element in the XML document; there will be a corresponding endElement() event for every startElement() event (even when the element is empty). All of the element's content will be reported, in order, before the corresponding endElement() event.

      If the element name has a namespace prefix, the prefix will still be attached. Note that the attribute list provided will contain only attributes with explicit values (specified or defaulted): #IMPLIED attributes will be omitted.

      Specified by:
        `startElement` in interface `org.xml.sax.DocumentHandler`
      Parameters:
        `tagName` - The element type name.
        `attrList` - The attributes attached to the element, if any.
      Throws:
        `org.xml.sax.SAXException` - Any SAX exception, possibly wrapping another exception.
      See Also:
        `DocumentHandler.endElement(java.lang.String)`, `AttributeList`

    - #### endElement

          public void endElement(java.lang.String tagName)
                          throws org.xml.sax.SAXException

      Description copied from interface: `org.xml.sax.DocumentHandler`
      Receive notification of the end of an element.

      The SAX parser will invoke this method at the end of every element in the XML document; there will be a corresponding startElement() event for every endElement() event (even when the element is empty).

      If the element name has a namespace prefix, the prefix will still be attached to the name.

      Specified by:
        `endElement` in interface `org.xml.sax.DocumentHandler`
      Parameters:
        `tagName` - The element type name
      Throws:
        `org.xml.sax.SAXException` - Any SAX exception, possibly wrapping another exception.

    - #### characters

          public void characters(java.lang.String text)
                          throws org.xml.sax.SAXException

      Throws:
        `org.xml.sax.SAXException`

    - #### characters

          public void characters(char[] text,
                        int start,
                        int length)
                          throws org.xml.sax.SAXException

      Description copied from interface: `org.xml.sax.DocumentHandler`
      Receive notification of character data.

      The Parser will call this method to report each chunk of character data. SAX parsers may return all contiguous character data in a single chunk, or they may split it into several chunks; however, all of the characters in any single event must come from the same external entity, so that the Locator provides useful information.

      The application must not attempt to read from the array outside of the specified range.

      Note that some parsers will report whitespace using the ignorableWhitespace() method rather than this one (validating parsers must do so).

      Specified by:
        `characters` in interface `org.xml.sax.DocumentHandler`
      Parameters:
        `text` - The characters from the XML document.
        `start` - The start position in the array.
        `length` - The number of characters to read from the array.
      Throws:
        `org.xml.sax.SAXException` - Any SAX exception, possibly wrapping another exception.
      See Also:
        `DocumentHandler.ignorableWhitespace(char[], int, int)`, `Locator`

    - #### ignorableWhitespace

          public void ignorableWhitespace(char[] text,
                                 int start,
                                 int length)
                                   throws org.xml.sax.SAXException

      Description copied from interface: `org.xml.sax.DocumentHandler`
      Receive notification of ignorable whitespace in element content.

      Validating Parsers must use this method to report each chunk of ignorable whitespace (see the W3C XML 1.0 recommendation, section 2.10): non-validating parsers may also use this method if they are capable of parsing and using content models.

      SAX parsers may return all contiguous whitespace in a single chunk, or they may split it into several chunks; however, all of the characters in any single event must come from the same external entity, so that the Locator provides useful information.

      The application must not attempt to read from the array outside of the specified range.

      Specified by:
        `ignorableWhitespace` in interface `org.xml.sax.DocumentHandler`
      Parameters:
        `text` - The characters from the XML document.
        `start` - The start position in the array.
        `length` - The number of characters to read from the array.
      Throws:
        `org.xml.sax.SAXException` - Any SAX exception, possibly wrapping another exception.
      See Also:
        `DocumentHandler.characters(char[], int, int)`

    - #### processingInstruction

          public void processingInstruction(java.lang.String target,
                                   java.lang.String instruction)
                                     throws org.xml.sax.SAXException

      Description copied from interface: `org.xml.sax.DocumentHandler`
      Receive notification of a processing instruction.

      The Parser will invoke this method once for each processing instruction found: note that processing instructions may occur before or after the main document element.

      A SAX parser should never report an XML declaration (XML 1.0, section 2.8) or a text declaration (XML 1.0, section 4.3.1) using this method.

      Specified by:
        `processingInstruction` in interface `org.xml.sax.DocumentHandler`
      Parameters:
        `target` - The processing instruction target.
        `instruction` - The processing instruction data, or null if none was supplied.
      Throws:
        `org.xml.sax.SAXException` - Any SAX exception, possibly wrapping another exception.

    - #### getHTMLDocument

          public org.w3c.dom.html.HTMLDocument getHTMLDocument()

    - #### setDocumentLocator

          public void setDocumentLocator(org.xml.sax.Locator locator)

      Description copied from interface: `org.xml.sax.DocumentHandler`
      Receive an object for locating the origin of SAX document events.

      SAX parsers are strongly encouraged (though not absolutely required) to supply a locator: if it does so, it must supply the locator to the application by invoking this method before invoking any of the other methods in the DocumentHandler interface.

      The locator allows the application to determine the end position of any document-related event, even if the parser is not reporting an error. Typically, the application will use this information for reporting its own errors (such as character content that does not match an application's business rules). The information returned by the locator is probably not sufficient for use with a search engine.

      Note that the locator will return correct information only during the invocation of the events in this interface. The application should not attempt to use it at any other time.

      Specified by:
        `setDocumentLocator` in interface `org.xml.sax.DocumentHandler`
      Parameters:
        `locator` - An object that can return the location of any SAX document event.
      See Also:
        `Locator`

Copyright © 1999-2010 The Apache Software Foundation. All Rights Reserved.